import java.io.*;
import java.util.*;

public class B {
    public void solve() throws IOException {
        long a = nextLong();
        long b = nextLong();
        long k = nextLong();
        int left = (int) Math.pow(a, 1.0 / 3);
        while (1L * left * left * left > a) {
        	--left;
        }
        while (1L * left * left * left < a) {
        	++left;
        }
        int right = (int) Math.pow(b, 1.0 / 3);
        while (1L * right * right * right < b) {
        	++right;
        }
        while (1L * right * right * right > b) {
        	--right;
        }
        int sqrA = (int) Math.sqrt(a);
        while (1L * sqrA * sqrA > a) {
        	--sqrA;
        }
        while (1L * sqrA * sqrA < a) {
        	++sqrA;
        }
        int sqrB = (int) Math.sqrt(b);
        while (1L * sqrB * sqrB < b) {
        	++sqrB;
        }
        while (1L * sqrB * sqrB > b) {
        	--sqrB;
        }
        long res = 0;
        for (int y = left; y <= right; ++y) {
        	long leftBoundSqr = 1L * y * y * y - k;
        	leftBoundSqr = Math.max(leftBoundSqr, 1L);
        	long rightBoundSqr = 1L * y * y * y + k;
        	if (rightBoundSqr < 1L) continue;
        	long leftBound = (long) Math.sqrt(leftBoundSqr);
        	while (leftBound * leftBound > leftBoundSqr) --leftBound;
        	while (leftBound * leftBound < leftBoundSqr) ++leftBound;
        	long rightBound = (long) Math.sqrt(rightBoundSqr);
        	while (rightBound * rightBound < rightBoundSqr) ++rightBound;
        	while (rightBound * rightBound > rightBoundSqr) --rightBound;
        	leftBound = Math.max(leftBound, sqrA);
        	rightBound = Math.min(rightBound, sqrB);
        	if (leftBound > rightBound) continue;
        	res += (rightBound - leftBound + 1);
        }
        out.println(res);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}
