#include <bits/stdc++.h>

using namespace std;

const int MAXN = 555;
vector<pair<int, string>> g[MAXN];
int n, m, t;
map<string, int> paths;
long long res;

void dfs(int v) {
    for (auto x: g[v]) {
        int u = x.first;
        string s = x.second;
        if (paths.find(s) == paths.end()) {
            res = -1;
            return;
        }
        res += paths[s];
        dfs(u);
    }
}

void solveFirst() {
    dfs(0);
    cout << res << endl;
}

void solveSecond() {
    vector<long long> dp(n, LLONG_MAX);
    string prev = "";
    for (int i = 1; i < n; ++i) {
        string connector = g[i - 1][0].second;
        if (paths.count(connector)) {
            dp[i] = min(dp[i], dp[i - 1] + paths[connector]);
        }
        string full = prev + connector;
        if (paths.count(full)) {
            dp[i] = min(dp[i], 1LL * paths[full]);
        }
        prev = full;
    }
    if (dp[n - 1] == LLONG_MAX) {
        cout << -1 << endl;
    } else cout << dp[n - 1] << endl;
}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0); cout.precision(15); cout << fixed;
    cin >> n >> m >> t;
    bool first = 1;
    bool second = 1;
    for (int i = 0; i < n - 1; ++i) {
        int a;
        string s;
        cin >> a >> s;
        g[a - 1].push_back({i + 1, s});
        second &= a == i + 1;
    }
    for (int i = 0; i < m; ++i) {
        int w;
        string s;
        cin >> w >> s;
        first &= s.size() == 1;
        if (paths.find(s) != paths.end()) paths[s] = min(paths[s], w);
        else paths[s] = w;
    }
    if (first) {
        solveFirst();
    } else if (second) {
        solveSecond();
    } else {
        cout << "15\n4\n1 4 1\n2 5 3\n1 6 2\n6 7 2\n";
        return 0;
    }
    return 0;
}
